
import 'package:cheminova/controller/rd_get_order_controller.dart';
import 'package:cheminova/models/get_rd_cancelled_model.dart';
import 'package:cheminova/models/rd_get_order_model.dart';
import 'package:cheminova/models/single_get_order_model.dart';
import 'package:cheminova/screens/rd%20orders/rd_cancelled_details_screen.dart';
import 'package:cheminova/screens/rd%20orders/rd_dispatched_details_screen.dart';
import 'package:cheminova/screens/rd%20orders/rd_order_details_screen.dart';
import 'package:cheminova/screens/rd%20orders/rd_pending_deatils.dart';
import 'package:cheminova/screens/rd%20orders/rd_processing_details.dart';
import 'package:cheminova/widgets/input_field.dart';
import 'package:cheminova/widgets/my_drawer.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';
import 'package:get/get.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:intl/intl.dart';

import '../../controller/get_rd_cancle_controller.dart';
import '../order_management/order_management_detail_screen.dart';

class RdCancelledScreen extends StatefulWidget {
  final PlacedOrdersResponse? getrdProduct;

  RdCancelledScreen({super.key, this.getrdProduct});

  @override
  State<RdCancelledScreen> createState() => _RdCancelledScreenState();
}

class _RdCancelledScreenState extends State<RdCancelledScreen> {
  final _searchController = TextEditingController();
  final List<String> _filterList = [ "new",
    "pending",
    "processing",
    "dispatched",
    "cancelled",
    "delivered",];
  int _selectedIndex = 0;
  final GetRDCancleController _getRdProductController = Get.put(GetRDCancleController());
  final GlobalKey<RefreshIndicatorState> _refreshIndicatorKey = GlobalKey<RefreshIndicatorState>();

  @override
  void initState() {
    super.initState();
    getOrder1();
  }

  Future<void> _onRefresh() async {
    await getOrder1();
    await Future.delayed(Duration(seconds: 1));
  }

  Future<void> getOrder1() async {
    await _getRdProductController.getRDCancleProduct();
    if (_getRdProductController.productRDList.isEmpty) {
      print("No orders found.");
    } else {
      print("Orders fetched successfully");
    }
  }

  String capitalizeFirstLetter(String text) {
    if (text.isEmpty) return text;
    return text[0].toUpperCase() + text.substring(1).toLowerCase();
  }

  String formatDate(String apiDate) {
    // Parse the API date string into a DateTime object
    DateTime parsedDate = DateTime.parse(apiDate).toLocal(); // Convert to local time

    // Format the date and time according to your specified format
    String formattedDate = DateFormat('EEE MMM dd yyyy').format(parsedDate);

    return formattedDate; // Return the formatted date string
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      extendBodyBehindAppBar: true,
      appBar: AppBar(
        centerTitle: true,
        backgroundColor: Colors.transparent,
        elevation: 0,
        leading: Builder(
          builder: (context) {
            return GestureDetector(
              onTap: () => Scaffold.of(context).openDrawer(),
              child: Padding(
                padding: const EdgeInsets.all(16.0),
                child: SvgPicture.asset('assets/svg/menu.svg'),
              ),
            );
          },
        ),
        actions: [
          GestureDetector(
            onTap: () => Get.back(),
            child: Padding(
              padding: const EdgeInsets.all(8.0),
              child: SvgPicture.asset('assets/svg/back_arrow.svg'),
            ),
          ),
        ],
        title: const Text("RD Cancelled Order"),
      ),
      drawer: MyDrawer(),
      body: Stack(
        fit: StackFit.expand,
        children: [
          Image.asset('assets/images/image_1.png', fit: BoxFit.cover),
          SafeArea(
            child: SingleChildScrollView(
              child: Padding(
                padding: EdgeInsets.only(bottom: MediaQuery.of(context).viewInsets.bottom),
                child: RefreshIndicator(
                  key: _refreshIndicatorKey,
                  onRefresh: _onRefresh,
                  color: Colors.black,
                  backgroundColor: Colors.white,
                  child: Column(
                    mainAxisSize: MainAxisSize.min,
                    children: [
                      InputField(
                        hintText: "Search Order",
                        labelText: "Search Order",
                        controller: _searchController,
                      ),
                      SizedBox(height: Get.height * 0.035),
                      Card(
                        margin: const EdgeInsets.symmetric(horizontal: 18),
                        shape: RoundedRectangleBorder(
                          borderRadius: BorderRadius.circular(19),
                          side: const BorderSide(color: Color(0xFFFDFDFD)),
                        ),
                        color: const Color(0xFFB4D1E5).withOpacity(0.9),
                        child: Padding(
                          padding: const EdgeInsets.all(12.0),
                          child: Column(
                            mainAxisSize: MainAxisSize.min,
                            children: [
                              // SizedBox(
                              //   height: Get.height * 0.05,
                              //   child: ListView.builder(
                              //     shrinkWrap: true,
                              //     scrollDirection: Axis.horizontal,
                              //     itemCount: _filterList.length,
                              //     itemBuilder: (context, index) => Padding(
                              //       padding: const EdgeInsets.symmetric(horizontal: 4),
                              //       child: GestureDetector(
                              //         onTap: () {
                              //           setState(() {
                              //             _selectedIndex = index; // Update selected index
                              //           });
                              //           // Navigate to different screens based on selected tab
                              //           switch (_filterList[index]) {
                              //             case "new":
                              //             //  Get.to(YourScreen1()); // Navigate to "new" orders screen
                              //               break;
                              //             case "pending":
                              //             // Get.to(YourScreen2()); // Navigate to "pending" orders screen
                              //               break;
                              //             case "processing":
                              //             //  Get.to(YourScreen3()); // Navigate to "processing" orders screen
                              //               break;
                              //           // Add more cases for other statuses
                              //             case "dispatched":
                              //             // Get.to(YourScreen4()); // Navigate to dispatched orders
                              //               break;
                              //             case "cancelled":
                              //             //   Get.to(YourScreen5()); // Navigate to cancelled orders
                              //               break;
                              //             case "delivered":
                              //             //Get.to(YourScreen6()); // Navigate to delivered orders
                              //               break;
                              //             default:
                              //             // Get.to(YourScreen1()); // Default screen
                              //           }
                              //         },
                              //         child: Chip(
                              //           label: Text(capitalizeFirstLetter(  _filterList[index])
                              //             ,
                              //             style: GoogleFonts.roboto(
                              //               fontSize: 14,
                              //               fontWeight: FontWeight.w500,
                              //               color: _selectedIndex == index ? Colors.white : Colors.black, // Change color when selected
                              //             ),
                              //           ),
                              //           backgroundColor: _selectedIndex == index ? Colors.blue : Colors.grey[300], // Change color when selected
                              //         ),
                              //       ),
                              //     ),
                              //   ),
                              // ),
                              SizedBox(
                                height: Get.height * 0.6,
                                child: Obx(() {
                                  if (_getRdProductController.productRDList.isEmpty) {
                                    return Center(
                                      child: Text(
                                        'No Orders Found',
                                        style: GoogleFonts.roboto(fontSize: 14),
                                      ),
                                    );
                                  }

                                  final Set<String> uniqueOrderIds = {};
                                  final List<GetRdCancelledModel> uniqueOrders = [];

                                  for (var order in _getRdProductController.productRDList) {
                                    if (uniqueOrderIds.add(order.id)) {
                                      uniqueOrders.add(order);
                                    }
                                  }

                                  if (uniqueOrders.isEmpty) {
                                    return Center(
                                      child: Text(
                                        'No Orders Found',
                                        style: GoogleFonts.roboto(fontSize: 14),
                                      ),
                                    );
                                  }

                                  return ListView.builder(
                                    padding: EdgeInsets.zero,
                                    shrinkWrap: true,
                                    itemCount: uniqueOrders.length,
                                    itemBuilder: (context, index) {
                                      final order = uniqueOrders[index];

                                      // Combine product names into a single string
                                      final productNames = order.orderItems
                                          .map((item) => capitalizeFirstLetter(item.name))
                                          .join(', ');

                                      return Padding(
                                        padding: const EdgeInsets.symmetric(vertical: 8),
                                        child: Card(
                                          child: Column(
                                            crossAxisAlignment: CrossAxisAlignment.start,
                                            children: [
                                              Padding(
                                                padding: const EdgeInsets.fromLTRB(16, 8, 8, 0),
                                                child: Row(
                                                  mainAxisAlignment: MainAxisAlignment.start,
                                                  children: [
                                                    Text("Order ID: ", style: GoogleFonts.roboto(fontSize: 14, fontWeight: FontWeight.bold)),
                                                    Text("${order.uniqueId}")
                                                  ],
                                                ),
                                              ),
                                              Padding(
                                                padding: const EdgeInsets.fromLTRB(16, 8, 8, 0),
                                                child: Row(
                                                  crossAxisAlignment: CrossAxisAlignment.start, // Aligns the Column to the top of the Text
                                                  children: [
                                                    Text(
                                                      "Product Names: ",
                                                      style: GoogleFonts.roboto(
                                                        fontSize: 14,
                                                        fontWeight: FontWeight.bold,
                                                      ),
                                                    ),
                                                    Expanded(
                                                      child: Column(
                                                        crossAxisAlignment: CrossAxisAlignment.start, // Aligns text to the right within the Column
                                                        children: [
                                                          const SizedBox(height: 4), // Adds a small space between the label and the product names
                                                          for (int i = 0; i < productNames.split(",").length; i++)
                                                            Text(
                                                              '${i + 1}. ${productNames.split(",")[i].trim()}', // Adds index and trims whitespace
                                                              textAlign: TextAlign.left, // Aligns text to the right
                                                              style: GoogleFonts.roboto(
                                                                fontSize: 14,
                                                              ),
                                                            ),
                                                        ],
                                                      ),
                                                    ),
                                                  ],
                                                ),
                                              ),


                                              Padding(
                                                padding: const EdgeInsets.fromLTRB(16, 8, 8, 0),
                                                child: Row(
                                                  mainAxisAlignment: MainAxisAlignment.start,
                                                  children: [
                                                    Text("Order Date: ", style: GoogleFonts.roboto(fontSize: 14, fontWeight: FontWeight.bold)),
                                                    Text(formatDate("${order.createdAt}"))
                                                  ],
                                                ),
                                              ),
                                              Padding(
                                                padding: const EdgeInsets.fromLTRB(16, 8, 8, 8),
                                                child: Row(
                                                  mainAxisAlignment: MainAxisAlignment.start,
                                                  children: [
                                                    Text("Status: ", style: GoogleFonts.roboto(fontSize: 14, fontWeight: FontWeight.bold)),
                                                    Text(capitalizeFirstLetter("${order.status}"))

                                                  ],
                                                ),
                                              ),
                                              SizedBox(
                                                width: Get.width * 0.4,
                                                child: Padding(
                                                  padding: const EdgeInsets.all(8.0),
                                                  child: ElevatedButton(
                                                    onPressed: ()=>
                                                        Get.to(() =>
                                                            RdCancelledDetailScreen(
                                                                placedOrderList: uniqueOrders[index])), // Navigate to detail screen
                                                    style: ElevatedButton.styleFrom(
                                                      foregroundColor: Colors.white,
                                                      backgroundColor: const Color(0xFF004791),
                                                      shape: RoundedRectangleBorder(
                                                          borderRadius: BorderRadius.circular(10)),
                                                    ),
                                                    child: Text("View Details", style: GoogleFonts.roboto(fontSize: 14, fontWeight: FontWeight.w400)),
                                                  ),
                                                ),
                                              )
                                            ],
                                          ),
                                        ),
                                      );
                                    },
                                  );
                                }),
                              )
                            ],
                          ),
                        ),
                      ),
                    ],
                  ),
                ),
              ),
            ),
          ),
        ],
      ),
    );
  }
}

